#!/usr/bin/env python

import dbus
import xmlrpclib, time

bus = dbus.SessionBus()
obj = bus.get_object('org.kde.amarok', '/Player')
mtd = obj.get_dbus_method('GetMetadata', 'org.freedesktop.MediaPlayer')

def run():
    artist = ""
    title = ""
    server = xmlrpclib.ServerProxy("http://localhost:8888")
    track = {'title': '', 'artist':''}
    while True:
        nfo = mtd()
        try:
            track["artist"] = nfo['artist']
            track["title"] = nfo['title']
        except KeyError:
            pass
        
        if (((track["title"], track["artist"]) != (title, artist)) and (track["title"] != None)):
            title = str(track["title"])
            artist = str(track["artist"])
            server.showLyrics(artist, title)
        time.sleep(0.1)


if __name__ == "__main__":
    run()
