#!/usr/bin/env python
# -*- coding: utf-8 -*-

# IMPORTS
from mpd import (MPDClient, CommandError)
from socket import error as SocketError
from sys import exit
import xmlrpclib, time


## SETTINGS
##
HOST = 'localhost'
PORT = '6600'
PASSWORD = False
###


client = MPDClient()

try:
    client.connect(host=HOST, port=PORT)
except SocketError:
    exit(1)

if PASSWORD:
    try:
        client.password(PASSWORD)
    except CommandError:
        exit(1)

def run():
    artist = ""
    title = ""
    server = xmlrpclib.ServerProxy("http://localhost:8888")
    track = {'title': '', 'artist':''}
    while True:
        try:
            track["artist"] = client.currentsong()["artist"]
            track["title"] = client.currentsong()["title"]
        except KeyError:
            pass
        
        if (((track["title"], track["artist"]) != (title, artist)) and (track["title"] != None)):
            title = str(track["title"])
            artist = str(track["artist"])
            server.showLyrics(artist, title)
        time.sleep(0.1)

if __name__ == "__main__":
    run()
