#!/usr/bin/env python
# -*- coding: utf-8 -*-

import urllib2 
import urllib
import re
import logging
import commands
import os
import time
from ConfigParser import ConfigParser

class GoogleBlockedException(Exception):
    def __init__(self, reason):
        self.reason = reason
    def __str__(self):
        return self.reason

class GoogleQuery:
    def __init__(self, query, cookies, numres = 100, wait = 0):
        self.cookies = cookies
        self.googlog = logging.getLogger("GoogleQuery")
        config = ConfigParser()
        config.read("config.ini")
        self.enable_cracker = config.getboolean("Google", "bot_captcha")
        url = "http://www.google.com/search?ie=UTF8&oe=UTF8&num=" + str(numres) + "&start=" + "&q=" + urllib.quote_plus(query.encode("utf-8") )
        request = urllib2.Request(url)
        request.add_header('User-Agent', 'IE6 :D') 
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cookies)) 
        try:
            self.reply = opener.open(request)
        except urllib2.HTTPError, e:
            self.googlog.debug("Got google error:" + str(e.code))
            if (e.code == 503 and self.enable_cracker):
                self.googlog.debug("GOOGLE: Captcha coming... Dumping...")
                data = e.read()
                self.googlog.debug(data)
                regex = re.compile(r'"\/sorry\/image\?id=(.*?)&')
                cid = regex.search(data).group(1)
                regex = re.compile(r'name="continue" value="(.+?)"')
                conturl = regex.search(data).group(1)
                urllib.urlretrieve("http://sorry.google.com/sorry/image?id=" + cid + "&hl=en", "dump.png")
                os.system("display dump.png &")
                captcha = commands.getoutput('zenity --entry').strip()
                os.system("killall display")
                request = urllib2.Request("http://sorry.google.com/sorry/Captcha?continue=" + urllib.quote_plus(url) + "&id=" + cid + "&captcha=" + str(captcha) + "&submit=I%27m+human%21")
                request.add_header('Referer', e.geturl())
                request.add_header('User-Agent', 'IE6 :D') 
                try:
                    self.googlog.debug(opener.open(request).read())
                except:
                    pass
                cookies.save()
                self.__init__(query, cookies, numres, wait)
                return
            elif (e.code == 403):
                self.googlog.debug(e.read())
                self.googlog.info("Blocked from Google, cookie is probably banned. Waiting %d seconds to retry query and clearing cookies." % 2**wait)
                time.sleep(2**wait)
                cookies.clear()
                cookies.save()
                self.__init__(query, cookies, numres, wait + 1)
            elif ((e.code == 503) and (not self.enable_cracker)):
                raise GoogleBlockedException("You're blocked from Google.\nEnable bot_captcha in the [Google] section of config.ini or wait a while.")
            else:
                raise e
        self.page = self.reply.read()
    
    def get_all_urls(self):
        urlre = re.compile(r'<h3 class="r"><a href="(.+?)"')
        res = urlre.findall(self.page)
        self.googlog.debug(repr(res))
        return res
