#!/usr/bin/env python
# -*- coding: utf-8 -*-
import urllib
import re
import xml.sax.saxutils as saxutils

from htmlentitydefs import name2codepoint 
def replace_entities(match):
    try:
        ent = match.group(1)
        if ent[0] == "#":
            if ent[1] == 'x' or ent[1] == 'X':
                return unichr(int(ent[2:], 16))
            else:
                return unichr(int(ent[1:], 10))
        return unichr(name2codepoint[ent])
    except:
        return match.group()

entity_re = re.compile(r'&(#?[A-Za-z0-9]+?);')
def html_unescape(data):
    return entity_re.sub(replace_entities, data)


class LyricsPlugin:
    name = ""
    site = ""
    testurl = ""
    
    def url_match(self, url):
        pass
    
    def get_lyrics(self, url, title, artist):
        pass

    def no_strip(self, data):
        data = re.compile(r'<.*?>').sub("", data)
        return data.strip()

    def default_strip(self,data):
        data = html_unescape(data)
        data = re.compile(r'\r\n').sub("", data)
        data = re.compile(r'\n').sub("", data)
        data = re.compile(r'<br>').sub("\n", data)
        data = re.compile(r'<br />').sub("\n", data)
        data = re.compile(r'<br/>').sub("\n", data)
        data = re.compile(r'<BR>').sub("\n", data)
        # TODO: understand why next string sometimes results in fall
        #data = urllib.unquote(re.compile(r'%92').sub("&apos", urllib.quote(data)))
        data = re.compile(r'<.*?>').sub("", data)
        data = re.compile(r'Please enable javascript to see this content.').sub("", data)
        return data.strip()
