#!/usr/bin/env python
from LyricsPlugin import *
import re
import urllib2
import cookielib
import chardet
import logging
from Lyric import Lyric

def smartdecode(string):
    try:
        return unicode(string, chardet.detect(string)['encoding'])
    except Exception, e:
        print str(e)
        return string

class RegexLyrics(LyricsPlugin):
    siteregex = re.compile(r'')
    regex = re.compile(r'')
    charsetregex = re.compile(r'<meta[^<]*content=\"[^"]*charset=(.*?)[\" ]', re.I)
    defaultcharset = None
    stripfunction = LyricsPlugin.default_strip
    
    def url_match(self, url):
        if self.siteregex.search(url):
            return True
        else:
            return False
    
    def selftest(self):
        return self.get_lyrics(self.testurl, "", "")
    

    def get_lyrics(self, url, title, artist):
        try:
            cj = cookielib.LWPCookieJar()
            opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
            urllib2.install_opener(opener)
            page = urllib2.urlopen(url).read()
            result = self.regex.search(page)
            
            if not result or (result is None): 
                logging.debug("Regex failed")
                logging.debug(page)
                return None
            text = result.group(1)
            charsetmatch = self.charsetregex.search(page)
            
            try:
                textcharset = charsetmatch.group(1).lower()
                logging.debug(textcharset)
                if textcharset == "iso-8859-1":
                    logging.debug("detected iso-8859-1, replacing")
                    textcharset = "Windows-1252"
            except Exception, e:
                logging.debug("char detection error:" + str(e))
                pass
            methods = [
                lambda t: self.stripfunction(unicode(t, textcharset)),
                lambda t: self.stripfunction(unicode(t, self.defaultcharset)),
                lambda t: smartdecode(self.stripfunction(t)),
                lambda t: self.stripfunction(smartdecode(t)),
            ]
            for i,method in enumerate(methods):
                try:
                    logging.debug("Trying to decode using method %d" % i)
                    lyrics = method(text)
                except:
                    # error - just test next method
                    logging.debug("Failed")
                    pass
                else:
                    # passed without errors - lyrics found
                    logging.debug("Success")
                    break
            else:
                # loop fell through without finding working method
                raise Exception("Cannot decode text")
            return Lyric(title, artist, url, self.name, self.site, lyrics)
        except Exception, e:
            logging.error(str(e))
            return None
