#!/usr/bin/env python

import time

from RegexLyrics import *

class Kithara(RegexLyrics):
    siteregex = re.compile(r'kithara\.vu')
    site = "kithara.vu"
    name = "Kithara greek"
    regex = re.compile(r'//-->(.*?)<hr size=1', re.DOTALL)
    testurl = "http://kithara.vu/ss.php?id=MzAzNTg3MzA1"

    def stripfunction(self,data):
        data = re.compile(r'\r\n').sub("", data)
        data = re.compile(r'\n').sub("", data)
        data = re.compile(r'</div>').sub("\n", data)
        data = urllib.unquote(re.compile(r'%92').sub("&apos", urllib.quote(data)))
        data = re.compile(r'<.*?>').sub("", data)
        return data.strip()
    
    def get_lyrics(self, url, title, artist):
        try:
            cj = cookielib.LWPCookieJar()
            opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
            urllib2.install_opener(opener)
            urlpath =url.split('/')
            homepath = urlpath[0]+'//'+urlpath[2]
            homepage = urllib2.urlopen(homepath).read()
            time.sleep(3)
            page = urllib2.urlopen(url).read()
            result = self.regex.search(page)
            if result:
                return Lyric(title, artist, url, self.name, self.site, self.stripfunction(result.group(1)))
            else:
                return None
        except Exception, e:
            print str(e)
            return None

if __name__ == "__main__":
    a = Kithara()
    print a.selftest().lyrics


